#include-once

;IdleIt v1.0
;By GtaSpider
;just a quick'n'dirty version, but well... it works

Global Const $IDLEIT_IDLE	= 1
Global Const $IDLEIT_BACK	= 2

Global $idleit_param_time = 300
Global $idleit_param_struct,$idleit_param_user32,$idleit_param_currentticks
Global $idleit_param_idle = False
Global $idleit_param_timer
Global $idleit_func_idle = False
Global $idleit_func_back = False

Global $idleit_adlib_time = 250

;===============================================================================
;
; Function Name:   	_IdleIt_Initalize($sIdleTime = 300)
; Description::		Initalize IdleIt
; Parameter(s):   	sIdleTime: Time in Seconds when the script should set the idle status/call the idle function
; Requirement(s):  	User23.dll, Kernel32.dll
; Return Value(s): 	On Success: 1
;				On Error: 	Return 0 and sets error:
;						@error = 1: Can't open user32.dll
;						@error = 2: GetTickCount returns error
;						@error = 3: Error by calling IdleItAdlib function
; Author(s):       		GtaSpider
;
;===============================================================================
;
Func _IdleIt_Initalize($sIdleTime = 300)
	_IdleIt_Stop()
	Global $idleit_param_time = $sIdleTime
	Global $idleit_param_struct = DllStructCreate("uint;dword")
	DllStructSetData($idleit_param_struct, 1, DllStructGetSize($idleit_param_struct))

	Global $idleit_param_user32 = DllOpen("user32.dll")
	If @error Then Return SetError(1,0,0)
	Local $aiTicks = DllCall("Kernel32.dll", "dword", "GetTickCount")
	If @error Then
		_IdleIt_Stop()
		Return SetError(2, 0, 0)
	EndIf
	Global $idleit_param_timer = TimerInit()
	Global $idleit_param_currentticks = $aiTicks[0]+50 ;+50 buffer

	__IdleIt_Adlib()
	If @error Then
		_IdleIt_Stop()
		Return SetError(3, 0, 0)
	EndIf

	AdlibRegister("__IdleIt_Adlib",$idleit_adlib_time)
	Return 1
EndFunc

;===============================================================================
;
; Function Name:   	_IdleIt_Stop()
; Description::		Stop IdleIt
; Parameter(s):		-
; Requirement(s):	-
; Return Value(s):	Allways 1
; Author(s):		Gtaspider
;
;===============================================================================
;

Func _IdleIt_Stop()
	If $idleit_param_user32 Then DllClose($idleit_param_user32)
	AdlibUnRegister("__IdleIt_Adlib")
	Global $idleit_param_struct = '' ;Free Struct
	Global $idleit_func_idle = False
	Global $idleit_func_back = False
	Return 1
EndFunc


;===============================================================================
;
; Function Name:   	_IdleIt_Hook($iHook,$sFunc)
; Description::    	Set ups the Hook Functions
; Parameter(s):    	$iHook: 	$IDLEIT_IDLE: 		Set up the function which should called when the idle status arrived
;						$IDLEIT_BACK: 	Set up the function which should called when the user is back
;				$sFunc:	The Function name
; Requirement(s):	-
; Return Value(s):	Allways 1
; Author(s):		GtaSpider
;
;===============================================================================
;

Func _IdleIt_Hook($iHook,$sFunc)
	Switch $iHook
		Case $IDLEIT_IDLE
			Global $idleit_func_idle = $sFunc
		Case $IDLEIT_BACK
			Global $idleit_func_back = $sFunc
	EndSwitch
EndFunc



Func __IdleIt_Adlib()
	Local $aResult = DllCall($idleit_param_user32, "bool", "GetLastInputInfo", "ptr", DllStructGetPtr($idleit_param_struct))
	If @error Or $aResult[0] = 0 Then Return SetError(1,@error, 0)

	Local $iDiff = $idleit_param_currentticks - DllStructGetData($idleit_param_struct, 2) + TimerDiff($idleit_param_timer)
	If $iDiff < 0 Then $iDiff = DllStructGetData($idleit_param_struct, 2)

	If $idleit_func_idle And (Not $idleit_param_idle) Then
		If $iDiff/1000 >= $idleit_param_time Then
			Call($idleit_func_idle)
			Global $idleit_param_idle = True
		EndIf
	EndIf
	If $idleit_func_back And $idleit_param_idle Then
		If $iDiff < $idleit_adlib_time + 50 Then ;+50 Buffer
			Call($idleit_func_back)
			Global $idleit_param_idle = False
		EndIf
	EndIf


EndFunc

